#!/bin/bash

#ARGS[0] - Milestone
#ARGS[1] - Date
#ARGS[2] - Machine

ARGS=("$@")
if [ "$#" -lt 2 ]; then
    echo "Error: Please provide all required parameters."
    exit 1
fi

if [ $ARGS[2]=="nuc" ];then	
	machine='192.168.99.52' #Minnowmax64
else
	machine='192.168.99.56' #Minnowmax64
fi

echo "Removing older data..."
rm -rf /work/weekly/runtime/compliance
echo "Recreating folders"
mkdir -p /work/weekly/runtime/compliance/logs/
echo "Uploading script"
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null /lava_test/scripts/compliance-local.py root@$machine:/home/root/ 
echo "Starting remote compliance tests..."
rsh -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine "python /home/root/compliance-local.py" ${ARGS[0]} ${ARGS[1]}
echo "Backing up logs"
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine:/opt/ltp/testcases/open_posix_testsuite/posix.log /work/weekly/runtime/compliance/logs/
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine:/opt/ltp/result-${ARGS[0]}-${ARGS[1]}.fulllog /work/weekly/runtime/compliance/logs/
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine:/opt/ltp/results/result-${ARGS[0]}-${ARGS[1]}.log /work/weekly/runtime/compliance/logs/
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine:/opt/ltp/output/result-${ARGS[0]}-${ARGS[1]}.fail /work/weekly/runtime/compliance/logs/
scp -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@$machine:/var/opt/lsb/test/manager/results/x86-64-genericx86-64-*.tgz /work/weekly/runtime/compliance/logs/
