#!/usr/bin/python

import os
import sys
from iniparser import IniParser
import argparse

parser = argparse.ArgumentParser()
parser.add_argument("-r", "--release", help='release type', required=True)
parser.add_argument("--current", help='folder name', required=True)
parser.add_argument("-v", "--version", help='eclipse version', required=True)
parser.add_argument("-d", "--date", help='date', required=False)
parser.add_argument("-c", "--commit", help='commit hash', required=False)
args = parser.parse_args()

inifile = IniParser()

def print_lava(string):
  os.system('echo '+string)

print_lava("Writing configuration...")
status = os.system('scp valentin@10.237.112.247:/home/valentin/yocto/dogtail-0.9.0/examples/settings-eclipse.ini .')
if status != 0:
    print_lava("Cannot get settings file!")
    exit(1)
inifile.setValue("settings-eclipse.ini", "Run", "param1", args.release)
inifile.setValue("settings-eclipse.ini", "Run", "param2", args.current)
inifile.setValue("settings-eclipse.ini", "Run", "eclipse_version", args.version)
inifile.setValue("settings-eclipse.ini", "Run", "date", args.date)
inifile.setValue("settings-eclipse.ini", "Run", "commit", args.commit)
status = os.system('scp settings-eclipse.ini valentin@10.237.112.247:/home/valentin/yocto/dogtail-0.9.0/examples/')
if status != 0:
    print_lava("Cannot write settings file!")
    exit(1)

print_lava("Starting tests...")
os.system('rsh valentin@10.237.112.247 "cd /home/valentin/yocto/dogtail-0.9.0/examples;\
    export DISPLAY=:0;\
    ./runEclipse.py"')

###### get logs ######

logfile_results = '/home/valentin/eclipse-results/' + args.release + '/' + args.current + "-" + args.date + "/" + 'results-eclipse-' + args.version +".log"
print_lava("Getting log file...")
status = os.system('scp valentin@10.237.112.247:'+logfile_results+' results-eclipse.log')
if status != 0:
    print_lava("Cannot get log file!")
    exit(1)
os.system('Converting logfile to lava json...')
string = "python log2bundle.py results-eclipse.log runtime 2.1 PC weekly %s %s %s" % (args.commit, args.date, args.version)
print_lava(string)
status = os.system(string)
if status != 0:
    print_lava("Warning: Might not have converted the log succesfully!")
