#!/usr/bin/python

import time
import os
import sys
import subprocess
from datetime import datetime, timedelta
import glob

try:
  target = str(sys.argv[1])
  source_link = str(sys.argv[2])
except IndexError, NameError:
    print "Usage: install_img.py  <target> <AB Link>\n Example: install_img.py genericx86-64_nuc http://autobuilder.yoctoproject.org/pub/nightly/20150202-1"
    exit(1)

#beaglebone and edgerouter do not have hddimg. must be installed the old fashioned way

def print_lava(string):
  os.system('echo '+string)

string = "install_img.py with parameters %s and %s" % (target, source_link)
print_lava(string)

#set a default machine for safety
machine = "nuc"

try:
    machine = target.split("_")[1] # minnowmax
    bsp_image = target.split("_")[0] # genericx86-64-lsb
    if (machine == "64"):
        bsp_image = target
except:
    bsp_image = target
    #set some defaults if the machine is not set
    if target == "genericx86":
        machine = "minnowmax32"
    elif target == "genericx86-64":
        machine = "nuc"

if "qemu" not in bsp_image:
    if ("minnowmax" in machine) and ("64" in bsp_image):
      machine = "minnowmax64"
    elif ("minnowmax" in machine) and ("64" not in bsp_image):
      machine = "minnowmax32"
    if ("cherry" in machine) and ("64" in bsp_image):
      machine = "cherryhill64"
    elif ("cherry" in machine) and ("64" not in bsp_image):
      machine = "cherryhill32"


def prepare_image(target):
    if source_link != '--retest':
        if bsp_image == 'ptest':
            ptest_target = "genericx86-64"
            full_img_link = str(source_link)+'/machines/'+str(ptest_target)+'/core-image-sato-sdk-'+str(ptest_target)+'.hddimg'
            ramfs_file = str(source_link)+'/machines/'+str(ptest_target)+'/core-image-minimal-initramfs-'+str(ptest_target)+'.cpio.gz'          
        elif ('lsb' in bsp_image):
            lsb_target = bsp_image.split("_")[0].replace("-lsb","")
            full_img_link = str(source_link)+'/machines/'+str(lsb_target)+'-lsb/core-image-lsb-sdk-'+str(lsb_target)+'.hddimg'
            ramfs_file = str(source_link)+'/machines/'+str(lsb_target)+'-lsb/core-image-minimal-initramfs-'+str(lsb_target)+'.cpio.gz'
        else:
            full_img_link = str(source_link)+'/machines/'+str(bsp_image)+'/core-image-sato-sdk-'+str(bsp_image)+'.hddimg'
            ramfs_file = str(source_link)+'/machines/'+str(bsp_image)+'/core-image-minimal-initramfs-'+str(bsp_image)+'.cpio.gz'
        img_name = full_img_link.split("/")[-1]
        
        #Check image age to avoid re-download
        def modification_date(filename):
            t = os.path.getmtime(filename)
            return datetime.fromtimestamp(t)

        def reuse_image(image):
            if (bsp_image != 'ptest') and ("wic" not in source_link):
                files = []
                for folder in glob.glob("../../../*"):
                    try:
                        for f in os.listdir(os.path.join(folder,"poky","build")):
                            if f == image:
                                files.append(os.path.join(folder,"poky","build",f))
                    except:
                        pass
                    found_file = ''

                    if files != []:
                        for i in files:
                            if (i != '') and (modification_date(i) > datetime.now() - timedelta(hours=24)):
                                found_file = i

                        if found_file != '':
                            print "Copying %s here." % found_file
                            try:
                                os.system("cp %s %s" % (found_file, image))
                            except:
                                pass
                            return True
                        else:
                            print_lava("No re-usable image found nearby.")
                            return False


        if not reuse_image(img_name):
            string = "Downloading image : "+full_img_link
            print_lava(string)
            if bsp_image != 'ptest':
                process = subprocess.Popen('wget -q '+full_img_link+" "+ramfs_file, shell=True, stdout=subprocess.PIPE)
                process.wait()
                if process.returncode != 0:
                    print_lava("Error downloading image from autobuilder!")
                    exit(1)
            else:
                print_lava("Downloading ptest image...")
                process = subprocess.Popen('wget -q '+full_img_link+" "+ramfs_file, shell=True, stdout=subprocess.PIPE)
                process.wait()
                if process.returncode != 0:
                    print_lava("Error downloading image from autobuilder!")
                    exit(1)

        else:
            print_lava("Recent image already exists. Continuing without downloading...")
    else:
        img_name = "core-image-*"

    string = "Uploading image to usb switch (%s)..." % img_name
    print_lava(string)
    process = subprocess.Popen('scp ' + img_name +' root@192.168.99.50:/root/BSP_images/', shell=True, stdout=subprocess.PIPE)
    process.wait()
    if process.returncode != 0:
        print_lava("Error transfering image to switch!")
        exit(1)
    else:
        print_lava("Image upload successful. Starting install script on usb switch...")
        command = 'ssh -t root@192.168.99.50 \"cd /root/USB_SW; python upload_image.py '+bsp_image+' '+machine+'\"'
        print_lava(command)
        process = subprocess.Popen(command, shell=True)
        process.wait()
        if process.returncode != 0:
            print_lava("Error running install script on usb switch!")
            exit(1)
        else:
            print_lava("Image installation was succesfull. Starting tests...")

if (bsp_image != 'all') and ("qemu" not in str(bsp_image)):
    prepare_image(bsp_image)    
else:
    if ('qemu' in bsp_image):
        print_lava("Target is qemu, skipping all downloads...")
        exit(0)