#!/bin/bash

#ARGs[0] - image repo link
#ARGS[1] - test_type (runtime)
#ARGS[2] - testrun_type (weekly)
#ARGS[3] - commit
#ARGS[4] - date
#ARGS[5] - target
#ARGS[6] - retest without clonning
#ARGS[7] - test suits (auto) 
#ARGS[8] - notifications (yes)

ARGS=("$@")
if [ "$#" -lt 7 ]; then
    echo "Error: Plase provide all required parameters."
    exit 1
fi

ARGS6=${ARGS[6]:-no}
ARGS7=${ARGS[7]:-auto}
ARGS8=${ARGS[8]:-yes}

WORKING_DIR=/work/${ARGS[2]}/${ARGS[1]}/${ARGS[5]}
BUNDLE_PATH=/anonymous/${ARGS[2]}-${ARGS[1]}-${ARGS[5]}/

function get_bundle_file()
{
cd $WORKING_DIR/poky/build/
local result=$(ls *.bundle)
echo $result
}

if [ $ARGS6 == "no" ]; then

su lava -c '
export DISPLAY=:1 && \
mkdir -p '$WORKING_DIR' && chmod 775 '$WORKING_DIR' && \
cd '$WORKING_DIR'/ && \
rm -rf poky && \
git clone git://git.yoctoproject.org/poky && \
cd poky/ && \
git checkout '${ARGS[3]}' && \
git clone git://git.yoctoproject.org/meta-intel && \
git clone git://git.yoctoproject.org/meta-minnow && \
git clone git://git.yoctoproject.org/meta-qt3 && \
source oe-init-build-env && \
cd /lava_test/scripts/ && \
cp genbblayers.py log2bundle.py ptest2bundle.py powercontrol3.exp test-serialcontrol.exp img_prepare.sh install_img.py rack_autotests.py '$WORKING_DIR'/poky/build/ && \
cd '$WORKING_DIR'/poky/build/ && \
python genbblayers.py && \
python install_img.py '${ARGS[5]}' '${ARGS[0]}' && \
python -u rack_autotests.py '${ARGS[0]}' '${ARGS[1]}' '${ARGS[2]}' '${ARGS[3]}' '${ARGS[4]}' '${ARGS[5]}' '$ARGS7' '$ARGS8' 2>&1'

else

su lava -c '
export DISPLAY=:1 && \
cd /lava_test/scripts/ && \
cp genbblayers.py log2bundle.py ptest2bundle.py powercontrol3.exp test-serialcontrol.exp img_prepare.sh install_img.py rack_autotests.py '$WORKING_DIR'/poky/build/ && \
cd '$WORKING_DIR'/poky/ && \
source oe-init-build-env && \
python genbblayers.py && \
python install_img.py '${ARGS[5]}' --retest && \
python -u rack_autotests.py '${ARGS[0]}' '${ARGS[1]}' '${ARGS[2]}' '${ARGS[3]}' '${ARGS[4]}' '${ARGS[5]}' '$ARGS7' '$ARGS8' --retest 2>&1'

fi