#!/bin/bash

#ARGs[0] - image repo link
#ARGS[1] - test_type (runtime)
#ARGS[2] - testrun_type (weekly)
#ARGS[3] - commit
#ARGS[4] - date
#ARGS[5] - target
#ARGS[6] - retest without clonning
#ARGS[7] - test suits (auto) 

ARGS=("$@")
if [ "$#" -lt 7 ]; then
    echo "Error: Plase provide all required parameters."
    exit 1
fi

ARGS7=${ARGS[7]:-auto}

WORKING_DIR=/work/${ARGS[2]}/${ARGS[1]}/${ARGS[5]}
BUNDLE_PATH=/anonymous/${ARGS[2]}-${ARGS[1]}-${ARGS[5]}/

function get_bundle_file()
{
cd $WORKING_DIR/poky/build/
local result=$(ls *.bundle)
echo $result
}

if [ ${ARGS[6]} == "no" ]; then

su lava -c '
export DISPLAY=:1 && \
cd '$WORKING_DIR'/ && \
rm -rf poky && \
git clone git://git.yoctoproject.org/poky && \
cd poky/ && \
git checkout '${ARGS[3]}' && \
git clone git://git.yoctoproject.org/meta-intel && \
git clone git://git.yoctoproject.org/meta-minnow && \
git clone git://git.yoctoproject.org/meta-qt3 && \
source oe-init-build-env && \
cd /lava_test/scripts/ && \
cp genbblayers.py log2bundle.py ptest2bundle.py powercontrol3.exp run_hwrack_tests.py test-serialcontrol.exp '$WORKING_DIR'/poky/build/ && \
python genbblayers.py '$WORKING_DIR'/poky && \
cd '$WORKING_DIR'/poky/build/ && \
python -u run_hwrack_tests.py '${ARGS[0]}' '${ARGS[1]}' '${ARGS[2]}' '${ARGS[3]}' '${ARGS[4]}' '${ARGS[5]}' '$ARGS7' 2>&1' 

else

su lava -c '
export DISPLAY=:1 && \
cd '$WORKING_DIR'/poky/ && \
source oe-init-build-env && \
cd /lava_test/scripts/ && \
cp genbblayers.py log2bundle.py ptest2bundle.py powercontrol3.exp run_hwrack_tests.py test-serialcontrol.exp '$WORKING_DIR'/poky/build/ && \
python genbblayers.py '$WORKING_DIR'/poky && \
cd '$WORKING_DIR'/poky/build/ && \
rm -f *.bundle && \
python -u run_hwrack_tests.py '${ARGS[0]}' '${ARGS[1]}' '${ARGS[2]}' '${ARGS[3]}' '${ARGS[4]}' '${ARGS[5]}' '$ARGS7' --retest 2>&1'

fi
