#!/usr/bin/env python

import sys, os, time, re
from datetime import datetime, timedelta
import subprocess

def print_lava(string):
    #string = re.sub(r'\W+', ' ', string)
    os.system('echo \"'+string+'\"')

def detect_recent_install(ip):
    result = subprocess.check_output("rsh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no root@%s 'last' " % ip, shell=True)
    result = result.strip().split("\n")[-1].split("begins")[1].strip().split(" ")
    result = " ".join(result)
    #print "Image installed at: %s" % result
    install_time  = datetime.strptime(result, "%a %b %d %H:%M:%S %Y")
    now_time = subprocess.check_output("rsh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no root@%s 'date' " % ip, shell=True)
    now_time = datetime.strptime(now_time.strip(), "%a %b %d %H:%M:%S %Z %Y")
    #print "Time now: %s" % now_time
    try:
        timedelta =  str(now_time - install_time).split(":")[0]
    except:
        timedelta = "hella"
    return timedelta

def boot_no_stick(stick_name, board):
    command = "./SW_interface.py %s -s pc -m %s -u off -p off" % (stick_name, board)
    status = os.system(command)
    if status != 0:
        print_lava("Error switching stick!")
        exit(1)
    time.sleep(2)
    command = "./SW_interface.py %s -s pc -m %s -u off -p on" % (stick_name, board)
    status = os.system(command)
    if status != 0:
        print_lava("Error switching stick!")
        exit(1)

def boot_with_stick(stick_name, board):
    command = "./SW_interface.py %s -s board -m %s -u on -p off" % (stick_name, board)
    status = os.system(command)
    if status != 0:
        print_lava("Error switching stick!")
        exit(1)
    time.sleep(2)
    command = "./SW_interface.py %s -s board -m %s -u on -p on" % (stick_name, board)
    status = os.system(command)
    if status != 0:
        print_lava("Error switching stick!")
        exit(1)

def atompc_on_stick(stickname):
    os.system("./atompc_power_seq.sh on_stick "+stickname)

def atompc_on_nostick(stickname):
    os.system("./atompc_power_seq.sh on_nostick "+stickname)

def minnowmax_on_stick(arch, stick_name, board):
    string = "Arch is "+str(arch)    
    print_lava(string)
    boot_with_stick(stick_name, board)
    time.sleep(30)
    if (str(arch) == "32"):
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 32 bit from stick...")
        os.system("./boot_minnow.py usb 2 32")
    else:
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 64 bit from stick...")
        os.system("./boot_minnow.py usb 3 64")

def minnowmax_on_stick_vanilla(arch, stick_name, board):
    string = "Arch is "+str(arch)    
    print_lava(string)
    boot_with_stick(stick_name, board)
    time.sleep(30)
    if (str(arch) == "32"):
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 32 bit from stick vanilla...")
        os.system("./boot_minnow.py install 2 32")
    else:
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 64 bit from stick vanilla...")
        os.system("./boot_minnow.py install 3 64")

def minnowmax_on_hdd(arch,stick_name, board):
    string = "Arch is "+str(arch)
    print_lava(string)  
    boot_no_stick(stick_name, board)
    time.sleep(30)
    if (str(arch) == "32"):
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 32 bit from hdd...")
        os.system("./boot_minnow.py hdd 2 32")
    else:
        #power cycle and switch stick
        print_lava("Booting Minnowboard Max 64 bit from hdd...")
        os.system("./boot_minnow.py hdd 3 64")

def cherryhill_on_stick(arch, stick_name, board):
    string = "Arch is "+str(arch)    
    print_lava(string)
    boot_with_stick(stick_name, board)
    time.sleep(30)
    print_lava("Powering on the Cherryhill...")
    os.system("./cherry_power.sh on_stick %s" % stick_name)
    time.sleep(30)
    if (str(arch) == "32"):
        #power cycle and switch stick
        print_lava("Booting Cherryhill 32 bit from stick...")
        os.system("./boot_cherry.py install 32")
    else:
        #power cycle and switch stick
        print_lava("Booting Cherryhill 64 bit from stick...")
        os.system("./boot_cherry.py install 64")

def cherryhill_on_hdd(arch,stick_name, board):
    string = "Arch is "+str(arch)
    print_lava(string)  
    boot_no_stick(stick_name, board)
    time.sleep(30)
    print_lava("Powering on the Cherryhill...")
    #os.system("./cherry_power.sh on_nostick")
    os.system("./cherry_power.sh on_stick %s" % stick_name)
    time.sleep(30)    
    if (str(arch) == "32"):
        #power cycle and switch stick
        print_lava("Booting Cherryhill 32 bit from hdd...")
        os.system("./boot_cherry.py hdd 32")
    else:
        #power cycle and switch stick
        print_lava("Booting Cherryhill 64 bit from hdd...")
        os.system("./boot_cherry.py hdd 64")

def nuc_on_stick(stick_name, board):
    print_lava("Booting NUC from stick...")
    boot_with_stick(stick_name, board)
    os.system("./boot_nuc.py usb")

def nuc_on_hdd(stick_name, board):
    print_lava("Booting NUC from HDD...")
    boot_with_stick(stick_name, board) #booting with stick on to hopefully prevent it from booting the hdd first instead of efi shell.
    os.system("./boot_nuc.py hdd")

def nuc_on_stick_vanilla(stick_name, board):
    print_lava("Booting NUC from stick vanilla...")
    boot_with_stick(stick_name, board)
    os.system("./boot_nuc.py install")

cfg_dir='/root/USB_SW/config_files/'
img_dir='/root/BSP_images/'

try:
    bsp=sys.argv[1]
    target_machine=sys.argv[2]
except IndexError, NameError:
    print_lava("Usage: upload_image.py <image type> <target machine> ex: genericx86 minnowmax32")
    exit(1)

string = "upload_image.py with parameters %s and %s" %(bsp, target_machine)
print_lava(string)

if 'qemu' in bsp:
    print_lava("Target is qemu, skipping these steps...")
    exit(0)

img_file=''

if 'lsb' in bsp:
    bsp = bsp.replace("-lsb","")
    img_file=img_dir +'core-image-lsb-sdk-'+bsp+'.hddimg'
elif 'ptest' in bsp:
    if 'nuc' in target_machine:
        img_file=img_dir +'core-image-sato-sdk-genericx86-64.hddimg'
    else:
        img_file=img_dir +'core-image-sato-sdk-genericx86.hddimg'
else:
    img_file=img_dir +'core-image-sato-sdk-'+bsp+'.hddimg'

print_lava("Looking for "+img_file+"...")

if not os.path.isfile(img_file):
    print_lava("File not found")
    exit(1)

print_lava("Starting installation of image...")
# step 2: detect stick

#map machine from image name
board = ''
map_file = open(cfg_dir+'machine2image.cfg')
for line in map_file:
    if line.split(":")[1] == bsp:
        if target_machine.lower() in line.split(":")[0].lower():
            board = line.split(":")[0]
map_file.close()

#detect stick to write
print_lava("Detecting stick to write...")
command = './rezerve_stick.py ' + board + ' > out'
os.system(command)
f = open('out','r')
stick_name = f.readline()
f.close()
os.remove('out')

stick_name = re.sub(r'\W+', '', stick_name)
print_lava("Selected stick: "+stick_name)

# step 3: write image to stick
print_lava("Writing image on stick...")
command = './image_on_stick.sh '+img_file.split("/")[-1]+' '+stick_name
status = os.system(command)
if status != 0:
    print_lava("Error writing image to stick!")
    exit(1)

# step 4: commute stick to board
print_lava("Commuting stick to board...")

if (board == "atompc"):
    atompc_on_stick(stick_name)
elif (board == "minnowmax32"):
    minnowmax_on_stick_vanilla(32, stick_name, board)    
elif (board == "minnowmax64"):
    minnowmax_on_stick_vanilla(64, stick_name, board)
elif (board == "cherryhill32"):
    #cherryhill_on_stick(32, stick_name, board)
    print_lava("Live booting Cherryhill because of hdd bug!")
    cherryhill_on_hdd(32, stick_name, board) # currently the cherryhill platform does not support hdd so we test on live boot
elif (board == "cherryhill64"):
    #cherryhill_on_stick(64, stick_name, board)
    print_lava("Live booting Cherryhill because of hdd bug!")
    cherryhill_on_hdd(64, stick_name, board)
elif ("nuc" in board.lower()):
    nuc_on_stick_vanilla(stick_name, board)
else:
    boot_with_stick(stick_name, board)

#reboot machine
def wait_for_ping(host='192.168.99.200',timeout=500):
    start_time = int(time.time())
    string = "Waiting for image to come online (%s)..." % host
    print_lava(string)
    response = 1
    while response != 0:
        response = os.system("ping -c 1 "+host+"  > /dev/null 2>&1")
        if (int(start_time) + int(timeout)) < int(time.time()):
            print_lava("Timeout reached, image still not available!")
            return 1
        time.sleep(1)

    if response == 0:
        print_lava('Image is up!')
        return 0

def get_bsp_ip(board):
    dhcp_ip = ''
    command = 'ssh cornel@10.237.112.97 \"cat /etc/dhcp/dhcpd.conf\" > out'
    os.system(command)
    with open('out', 'r') as content_file:
        dhcp_conf = content_file.read()    
    os.remove('out')
    dhcp_conf = dhcp_conf.split("\n")
    for i in xrange(len(dhcp_conf)):
        if (board in dhcp_conf[i]) and ("host " in dhcp_conf[i]):
           dhcp_ip = dhcp_conf[i+2].split("fixed-address")[1].strip()[:-1]
    if dhcp_ip != '':
        return dhcp_ip
    else:
        return 1

board_ip = get_bsp_ip(board)

# step 5: wait to install and decommute stick

if "cherry" not in board: # currently the cherryhill platform does not support hdd so we test on live boot
    print_lava("We presume the image is installing. Waiting 10 minutes...")
    time.sleep(500)
    print_lava("We presume the installation was fine. Restarting...")
else:
    print_lava("Live booting cherryhill...")
    time.sleep(30)

if (board == "atompc"):
    atompc_on_nostick(stick_name)
elif ("minnowmax" in board):
    time.sleep(60)
    if "32" in board:
        minnowmax_on_hdd(32, stick_name, board)
    else:
        minnowmax_on_hdd(64, stick_name, board)
elif ("cherry" in board):
    #time.sleep(60)
    #if "32" in board:
    #    cherryhill_on_hdd(32, stick_name, board)
    #else:
    #    cherryhill_on_hdd(64, stick_name, board)
    pass
elif ("nuc" in board.lower()):
    nuc_on_hdd(stick_name, board)

# step 6: wait for image to boot and ping it's dhcp ip

if board_ip != 1:
    started = wait_for_ping(board_ip,300)
    if (started == 0):
        print_lava("Image succesfully installed.")
        time.sleep(30)
        # Check if image is installed very recently
        if (detect_recent_install(board_ip) != "hella"):
            if (int(detect_recent_install(board_ip)) < 2):
                print_lava("An image was recently installed on board. Looking good.")
                exit(0)
            else:
                string = "An image was installed on board %s hours ago, does not look good!" % detect_recent_install(board_ip)
                print_lava(string)
                exit(1)
        else:
            print_lava("An image was installed on board a long time ago, does not look good!")
            exit(1)        
    else:
        print_lava("Timeout while waiting for image to boot first time! Reverting usb.")
        command = './SW_interface.py '+stick_name+' -s pc -m '+board+' -u off -p on'
        status = os.system(command)    
        exit(1)