#!/bin/bash

#ARGS[0] - commit
#ARGS[1] - date
#ARGS[2] - image type (genericx86)
#ARGS[3] - core type (core-image-sato-sdk)
#ARGS[4] - machine (minnowmax32)
#ARGS[5] - retest without cloning
#ARGS[6] - test suite (auto)
#ARGS[7] - notifications (yes)
#ARGS[8] - yocto-version (1.9)

ARGS=("$@")
if [ "$#" -lt 5 ]; then
    echo "Error: Please provide all required parameters."
    exit 1
fi

ARGS5=${ARGS[5]:-no}
ARGS6=${ARGS[6]:-auto}
ARGS7=${ARGS[7]:-yes}
ARGS8=${ARGS[8]:-master}

WORKING_DIR=/work/weekly/runtime/${ARGS[2]}_${ARGS[4]}/
BUNDLE_PATH=/anonymous/${ARGS[1]}-${ARGS[0]}-${ARGS[4]}/

if [ ${ARGS5} == "no" ]; then

su lava -c '
mkdir -p '$WORKING_DIR' && chmod 775 '$WORKING_DIR' && \
cd '$WORKING_DIR'/ && \
rm -rf poky && \
git clone git://git.yoctoproject.org/poky && \
cd poky/ && \
git checkout '${ARGS[0]}' && \
git clone git://git.yoctoproject.org/meta-intel && \
git clone git://git.yoctoproject.org/meta-minnow && \
git clone git://git.yoctoproject.org/meta-qt3 && \
source oe-init-build-env && \
cd /lava_test/scripts/ && \
cp genbblayers.py log2bundle.py ptest2bundle.py test_wic.py '$WORKING_DIR'/poky/build/ && \
cd '$WORKING_DIR'/poky/build/ && \
python -u test_wic.py --type '${ARGS[2]}' --core '${ARGS[3]}' --board '${ARGS[4]}' --suite '$ARGS6' --commit '${ARGS[0]}' --date '${ARGS[1]}' --notif '${ARGS7}' --version '${ARGS8}' 2>&1'

else

su lava -c '
export DISPLAY=:1 && \
cd '$WORKING_DIR'/poky/ && \
source oe-init-build-env && \
python -u test_wic.py --type '${ARGS[2]}' --core '${ARGS[3]}' --board '${ARGS[4]}' --suite '$ARGS6' --commit '${ARGS[0]}' --date '${ARGS[1]}' --notif '$ARGS7' --version '$ARGS8' 2>&1'

fi